﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using CustomComponents.Exceptions;

namespace KOP_Labs
{
    public partial class CustomComboBox : UserControl
    {
        public CustomComboBox()
        {
            InitializeComponent();
        }
        private string examp = "Введите текст от " + decimal.MinValue + " до" + decimal.MaxValue + " символов";
        
        public int? max = null;
        public int? min = null;
        public int? Max
        {
            get
            {
                return max;
            }
            set
            {
                if (value == null || value <= 0) return;
                max = value;
                
            }

        }
        public int? Min
        {
            get
            {
                return min;
            }
            set
            {
                if (value == null || value < 0) return;
                min = value;
                
            }

        }

        private EventHandler _changeEvent;
        public event EventHandler ChangeEvent
        {
            add
            {
                _changeEvent += value;
            }
            remove
            {
                _changeEvent -= value;
            }

        }
        private void textBox_TextChanged(object sender, EventArgs e)
        {
            _changeEvent?.Invoke(sender, e);
        }

        private void textBox_Enter(object sender, EventArgs e)
        {
            ToolTip tt = new ToolTip();
            tt.Show(examp, textBox, 30, -20, 2000);
        }

        public string? TextBoxValue
        {
            get
            {
                if (Min == null || Max == null)
                {
                    throw new NoBordersException("Границы не заданы");
                }
                if (textBox.Text.Length < Min || textBox.Text.Length > Max)
                {
                    throw new ArgumentOutOfRangeException("Ваша строка не входит в границы диапозона: " +  Min + " - " +  Max);
                }
                return textBox.Text;
            }
            set
            {
                if (value == null || value.Length < 0 || Max == null)
                {
                    return;
                }
                if (value.Length < Min && value.Length > Max)
                {
                    return;
                }
                textBox.Text = value;
            }
        }

    }
}
